﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinSchedule.DayView;
using Infragistics.Win.UltraWinToolTip;
using System.Threading;
using Infragistics.Win;
using Infragistics.Win.UltraWinSchedule;

namespace UltraDayViewWithUltraTooltipManager
{
    public partial class Form1 : Form
    {

        private System.Windows.Forms.Timer timer;
        public delegate void DelegateDefinition();
        private AppointmentUIElement appUIElement;

        public Form1()
        {
            InitializeComponent();

            timer = new System.Windows.Forms.Timer();
            timer.Interval = 100;
            timer.Tick += new EventHandler(timer_Tick);
        }

        private void timer_Tick(object sender, EventArgs e)
        {
            timer.Stop();
            DelegateDefinition delgate = new DelegateDefinition(CreateToolTip);
            ThreadStart threadStart = new ThreadStart(delegate { this.BeginInvoke(delgate); });
            Thread thread = new Thread(threadStart);
            thread.Start();
            timer.Start();
        }

        public void CreateToolTip()
        {
            UltraToolTipInfo info = new UltraToolTipInfo();
            info.ToolTipImage = ToolTipImage.Info;
            info.ToolTipTitle = "Appointemtns";

            EditorWithTextDisplayTextUIElement ddd = appUIElement.GetDescendant(typeof(EditorWithTextDisplayTextUIElement)) as EditorWithTextDisplayTextUIElement;
            if (ddd != null) info.ToolTipText = ddd.SelectableItem.ToString() ;
            else info.ToolTipText = "N/A";
           
            
            UltraToolTipManager man = new UltraToolTipManager();
            man.InitialDelay = 10;
            man.AutoPopDelay = 250;
            man.SetUltraToolTip(this, info);
            man.ShowToolTip(this);
        }

        private void ultraDayView1_MouseEnterElement(object sender, Infragistics.Win.UIElementEventArgs e)
        {
            appUIElement = e.Element.GetAncestor(typeof(AppointmentUIElement)) as AppointmentUIElement;
            if (appUIElement != null)
            {
                timer.Enabled = true;
            }

        }

        private void ultraDayView1_MouseLeaveElement(object sender, Infragistics.Win.UIElementEventArgs e)
        {
            timer.Enabled = false;
            appUIElement = null;
        }

        private void ultraDayView1_BeforeAppointmentToolTipDisplayed(object sender, Infragistics.Win.UltraWinSchedule.BeforeAppointmentToolTipDisplayedEventArgs e)
        {
            e.Cancel = true;
        }
    }
}
